'use strict';


/**************************************************************************************
GLOBALS
numColors: used in the pickColor functon to count the number of colors picked for the 
  palette
colorLimit: determined in the easy, medium, and hard functions. It represnts the max
  amount of colors we can have in our palette. If a user tries to go above this number
  an error is displayed
palette: this is the array that will hold our palette colors (used in many functions, 
  filled in pickColor)
***************************************************************************************/
var numColors;
var colorLimit;
var palette = []; 
var pic;
var w; 
var h;
var imageData;
var imgData;
//used for changing number of palette canvases that appear
var levelEasy = false;
var levelMedium = false;
var levelHard = false;
var firstTime = true;
//used in onclicks to see what needs to be displayed after functions are called
var onPainting; 
var onOutline;



/**************************************************************************************
FUNCTION PURPOSE: Gets uploaded image from file upload in HTML
PARMATERS: input (this represnts the image we input)
REFRENCES: https://www.w3schools.com/tags/att_input_type_file.asp
***************************************************************************************/
function readURL(input) {
	var image = document.getElementById('output'); //get my image from html file
	image.src = URL.createObjectURL(event.target.files[0]); //this is what loads the image from file upload
}

/**************************************************************************************
FUNCTION PURPOSE: On click for the easy button. Set colorLimit.
PARMATERS: none
***************************************************************************************/
function easy() //change to 6 8 and 10???
{
  numColors = 0; 
  levelEasy = true;
  colorLimit = 5;
  //change the colors of the buttons
  var easyButton = document.getElementById("e").style.background = '#FF0000';
  var easyButton = document.getElementById("m").style.background = '#696969';
  var easyButton = document.getElementById("h").style.background = '#696969';

  //if a previous level had been selected, get rid of the palette canvases if there are extras
  if(levelHard == true)
  {
    for(var i = 6; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "none";
    }
    //delete last 13 canvasses
    levelHard = false;
  }
  else if (levelMedium == true)
  {
    for(var i = 6; i <11; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "none";
    }
    levelMedium = false;
  }
  
}

/**************************************************************************************
FUNCTION PURPOSE: On click for the medium button
PARMATERS: none
***************************************************************************************/
function medium()
{
  numColors = 0;
  levelMedium = true;
  colorLimit = 10;
  var easyButton = document.getElementById("e").style.background = '#696969';
  var easyButton = document.getElementById("m").style.background = '#FF0000';
  var easyButton = document.getElementById("h").style.background = '#696969';

  if(levelHard == true)
  {
    for(var i = 11; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "none";
    }
    levelHard = false;
  }
  else if (levelEasy == true)
  {
    for(var i = 6; i <11; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "unset";
    }
    levelEasy = false;
  }
}

/**************************************************************************************
FUNCTION PURPOSE: On click for the hard button
PARMATERS: none
***************************************************************************************/
function hard()
{
  numColors = 0;
  levelHard = true;
  colorLimit = 18;
  var easyButton = document.getElementById("e").style.background = '#696969';
  var easyButton = document.getElementById("m").style.background = '#696969';
  var easyButton = document.getElementById("h").style.background = '#FF0000';

  if(levelEasy == true)
  {
    for(var i = 6; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "unset";
    }
    levelEasy = false;
  }
  else if (levelMedium == true)
  {
    for(var i = 11; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "unset";
    }
    levelMedium = false;
  }
}

/**************************************************************************************
FUNCTION PURPOSE: Display uploaded image on canvas
PARMATERS: none
REFRENCES: https://www.w3schools.com/html/html5_canvas.asp
***************************************************************************************/
function putPicOnCanvas()
{ 
  //get our image from html and store it in pic
  pic = new Image();
  var pic = document.getElementById("output");

  //get the picture's dimentions 
  var w = pic.width || pic.naturalWidth; 
  var h = pic.height || pic.naturalHeight;

  //refrence our canvas and canvas context from html
  var canvas = document.getElementById('canvas_one'); 
  var context = canvas.getContext('2d');

  //get canvas dimentions
  canvas.width = w; 
  canvas.height = h;

  //paste our image on our canvas
  context.drawImage(pic, 0, 0, w, h); 

  //CODE BELOW IS FOR OUR PALETTE CANVASES

  var i;

  for(i = 1; i <= colorLimit; i++) //only have as many as our limit
  {
    //get canvases and context
    var c = document.getElementById("palette" + i);
    var cContext = c.getContext("2d");

    //see if our browser allows for an eyedropper tool 
    if ('EyeDropper' in window) {
      //add an onclick to the palette canvases 
      c.addEventListener('click', pickColor); 
    }
    //fill canvas with grey, outline in black 
    cContext.fillStyle = "#dcdcdc"; //grey
    cContext.strokeStyle = "#000000"; //black
    cContext.fillRect(0,0, c.width, c.height);
    cContext.strokeRect(0,0, c.width, c.height);
  }

}

function test()
{
  if (numColors < 2)
  {
    alert("You must pick at least two colors for your palette");
  }
  else
  {
    loadPic();
  }
}

/**************************************************************************************
FUNCTION PURPOSE: This function operates as my main function. All the adjustments to the 
  picture are called within this function
PARMATERS: none
***************************************************************************************/
function loadPic() 
{
  var firstKMeans = true;
  var haveLabelLoc = false; 
  onPainting = false; 
  onOutline = true;
  
  //get our image from html and store it in pic
  var pic = new Image(); 
  var pic = document.getElementById("output"); 

  //get dimentions of pic
  var width = pic.width || pic.naturalWidth; 
  var height = pic.height || pic.naturalHeight;

  //get my canvas from HTML
  var canvas = document.getElementById('canvas_one'); 
  var context = canvas.getContext('2d');

  //adjust using pics dimentions
  w = canvas.width = width; 
  h = canvas.height = height;

  //draw pic onto canvas... necessary for getImageData down below
  context.drawImage(pic, 0, 0, width, height); 

  //this gets the data from the canvas and stores it as numbers in imageData
  //Image data is an array that has four indexs for each pixel representing colors
  imageData = context.getImageData(0, 0, width, height); 

  //kMeans function (take distance between paltette colors and all pixels and save the smallest (closest))
  var paletteMatrix = kMeans(imageData, palette);
  
  var oLine = outline(paletteMatrix);

  var finalColors = [{ r: 255, g: 255, b: 255 }, //white
    { r: 150, g: 150, b: 150 }]; //grey

  imgData = matrixToImageData(oLine, finalColors, context);

  context.putImageData(imgData, 0, 0);

  context.strokeStyle = "#000000";
  context.strokeRect(0,0, canvas.width, canvas.height);

  var updatedPaletteMatrix;

  var labelLocations;

  let original = document.createElement('button');
  original.innerHTML = 'Original';
  original.onclick = function()
  {
    context.drawImage(pic, 0, 0, w, h); 
    goBack.disabled = false;
    seeFinal.disabled = false;
    seeNumbers.disabled = true;
  }
  document.body.appendChild(original);

  let goBack = document.createElement('button');
  goBack.innerHTML = 'Outline';
  goBack.disabled = true;


  let refine = document.createElement('button'); 
  refine.innerHTML = 'Refine'; 
  //update my palette boxes
  refine.onclick = function() 
  { 
    firstKMeans = false;
    firstTime = true;

    updatedPaletteMatrix = kMeans(imageData, palette);
    updatePalette(updatedPaletteMatrix, imageData);
    oLine = outline(updatedPaletteMatrix);
    imgData = matrixToImageData(oLine, finalColors, context);
      
    if(onOutline)
    {
      context.putImageData(imgData, 0, 0);
    }
    else
    {
      var igData = generateFinal(updatedPaletteMatrix, oLine, context, palette);
      context.putImageData(igData, 0, 0);
      firstTime = true;
      haveLabelLoc = false;
    }
  }
 
  document.body.appendChild(refine);
//  refine gets rid of numbers.....refine flips a bool 
  let seeNumbers = document.createElement('button');
  seeNumbers.innerHTML = 'See Numbers';
  seeNumbers.onclick = function() 
  {

    if(firstTime == true && firstKMeans == true)
    {
      //this finds the regions large enough to hold number labels, and finds the center of these regions and holds the x and y values (represting pixel location)
      labelLocations  = findLabelRegions(paletteMatrix); 
      firstTime = false;
      haveLabelLoc = true;
    }
    else if(firstTime == true && firstKMeans == false)
    {
      labelLocations  = findLabelRegions(updatedPaletteMatrix); 
      firstTime = false;
      haveLabelLoc = true;
    }

    if(firstKMeans == true && onOutline)
    {
      oLine = outline(paletteMatrix);
      imgData = matrixToImageData(oLine, finalColors, context);
      context.putImageData(imgData, 0, 0);
    }
    else if(firstKMeans == false && onOutline)
    {
      oLine = outline(updatedPaletteMatrix);
      imgData = matrixToImageData(oLine, finalColors, context);
      context.putImageData(imgData, 0, 0);
    }

    context.font = "12px Georgia";
    context.fillStyle = "rgb(150, 150, 150)";
    for (var i = 0; i < labelLocations.length; i++) 
    {
      context.fillText(labelLocations[i].value + 1,
      labelLocations[i].x - 3,
      labelLocations[i].y + 4);
    }
  }
  document.body.appendChild(seeNumbers);

  let seeFinal = document.createElement('button');
  seeFinal.innerHTML = 'See Finished';
  seeFinal.onclick = function() 
  {
    onPainting = true; 
    onOutline = false;
    seeNumbers.disabled = false;

    if(firstKMeans == true)
    {
     var igData = generateFinal(paletteMatrix, oLine, context, palette);
    }
    else
    {
      var igData = generateFinal(updatedPaletteMatrix, oLine, context, palette);
    }
    context.putImageData(igData, 0, 0);
    goBack.disabled = false;
    seeFinal.disabled = true;
  }

  document.body.appendChild(seeFinal);
  document.body.appendChild(goBack);


  goBack.onclick = function() 
  {
    goBack.disabled = true;
    seeFinal.disabled = false;
    seeNumbers.disabled = false;
    onOutline = true;
    onPainting = false;

    context.putImageData(imgData, 0, 0);

    context.strokeStyle = "#000000";
    context.strokeRect(0,0, canvas.width, canvas.height);
    // draw numbers
    if(haveLabelLoc)
    {
      context.font = "12px Georgia"; 
      context.fillStyle = "rgb(150, 150, 150)";
      for (var i = 0; i < labelLocations.length; i++) 
      {
        context.fillText(labelLocations[i].value + 1,
        labelLocations[i].x - 3,
        labelLocations[i].y + 4);
      }
    }
  }
}

/**************************************************************************************
FUNCTION PURPOSE: This function updates our palette so we can refine the image
PARMATERS: paletteMatrix, imageData
***************************************************************************************/
function updatePalette(paletteMatrix, imageData)
{
  //calculate the average of all the colors associated with each palette color
  //update the palette with these averages
  var width = paletteMatrix[0].length;
  var height = paletteMatrix.length;

  for(var i = 0; i < palette.length; i++)
  {
    var numPixel = 0;

    var rgb = {r:0, g:0, b:0};

    for (var y = 0; y < height; y++) 
    {
      for (var x = 0; x < width; x++) 
      {
        if(paletteMatrix[y][x] == i)
        {
          numPixel++;
          //gets position in image data
          var t = (y * width + x) * 4; 
          rgb.r += imageData.data[t]; 
          rgb.g += imageData.data[t+1];
          rgb.b += imageData.data[t+2];     
        }
      } 
    }

    rgb.r = Math.floor(rgb.r/numPixel); 
    rgb.g = Math.floor(rgb.g/numPixel);
    rgb.b = Math.floor(rgb.b/numPixel);

    palette[i] = rgb;

  }
}

/**************************************************************************************
FUNCTION PURPOSE: This function converts our matrix to imageData to put on the canvas
PARMATERS: paletteMarrix, oLine (Might not need), context of our canvas, palette
***************************************************************************************/
function generateFinal(paletteMatrix, oLine, context, palette)
{
  var gMatrix = _.cloneDeep(paletteMatrix);

  var imageData = context.createImageData(gMatrix[0].length, gMatrix.length); 

  for(var y = 0; y < gMatrix.length; y++)
  {
    for (var x = 0; x < gMatrix[0].length; x++)
    {
      var i = (y * gMatrix[0].length + x) * 4; 

      //this is for if the user wants to display the outline in the final
      //they will have to compare the outline to the palette matrix and put 100's where 
      //the outline should go.
      // if (gMatrix[y][x] == 100)
      // {
      //   imageData.data[i] = 0;
      //   imageData.data[i+1] = 0;
      //   imageData.data[i+2] = 0;
      //   imageData.data[i+3] = 255; 
      // }
      // else 
      //{
        var color = palette[gMatrix[y][x]];
        imageData.data[i] = color.r; 
        imageData.data[i+1] = color.g;
        imageData.data[i+2] = color.b;
        imageData.data[i+3] = 255; 
      //}
    }
  }
  return imageData;
}

/**************************************************************************************
FUNCTION PURPOSE: Convert Matrix of closest palette colors to ImageData
PARMATERS: The line (where the outline will be), our two end colors (white background, black
  lines) and the canvas context
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/


function matrixToImageData(ol, fc, ctx) //outline, final colors, context of canvas
{
  //create ImageData based off of size of our outline matrix (also size of palette matrix)
  var imageData = ctx.createImageData(ol[0].length, ol.length);
  
  for(var y = 0; y < ol.length; y++)
  {
    for (var x = 0; x < ol[0].length; x++)
    {
      var i = (y * ol[0].length + x) * 4; 

      //determines where the pixel will be black or white
      var column = fc[ol[y][x]];
      //set the image data
      imageData.data[i] = column.r;
      imageData.data[i+1] = column.g;
      imageData.data[i+2] = column.b;
      imageData.data[i+3] = 255; //this is a default value
    }
  }
  return imageData;
}

/**************************************************************************************
FUNCTION PURPOSE: Create a matrix that holds which palette color each pixel is closest to
PARMATERS: Image data and our palette array
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function kMeans(imageData, palette)
{
  //create array
  var nearestMatrix = [];

  //for each entry in the array, make a new array the length of the width (This makes a matrix)
  for (var i =0; i < imageData.height; i++) //height will be represented by y below
  {
    nearestMatrix[i] = new Array(imageData.width);  //width will be represented by x below
  }

  //NOTE: this may not be necessary anymore. Could probably do every pixel (meaning i+=4. and i starts at 0)
  for(var i =4; i < imageData.data.length; i += 12) //must increase i by four because imagedata has four spots for each pixel(r,g,b,a)
  {
    //call getNearest and send it the palette and the color data in the pixel
    var closestColor = getClosest(palette, {
      r:imageData.data[i],
      g:imageData.data[i+1],
      b:imageData.data[i+2]
    });

    //take i/4 because each pixel holds four elements in the array for r,g,b,a
    var x = (i/4) % imageData.width; //determines row (%imageData.width keeps within matrix size)

    var y = Math.floor((i/4)/imageData.width); //determine column (should increase less frequently than row...)

    //holds which palette color is closest to this pixel, where y represnts pixel in relation to height 
    //and x represnts pixel in relation to width
    nearestMatrix[y][x] = closestColor; 

    //if doing every pixel, this code below could get deleted
    var j = i + 4;
    var k = i - 4;
    if(Math.floor((j/4)/imageData.width) == y && Math.floor((k/4)/imageData.width) == y )//if increasing/decreasing the x value does not change the y value (does not go to new colum)
    {
     nearestMatrix[y][x-1] = closestColor; 
     nearestMatrix[y][x+1] = closestColor; 
    }
    else if(Math.floor((j/4)/imageData.width) == y ) //if decreasing changes column but increaing does not
    {
      nearestMatrix[y][x+1] = closestColor; 

      var closestColor = getClosest(palette, { //calculate closest for k
        r:imageData.data[k],
        g:imageData.data[k+1],
        b:imageData.data[k+2]
      });

      var x = (k/4) % imageData.width; //determines row (%imageData.width keeps within matrix size)

      var y = Math.floor((k/4)/imageData.width); //determine column (should increase less frequently than row...)

      nearestMatrix[y][x] = closestColor; 

    }
    else if(Math.floor((k/4)/imageData.width) == y)
    {
      nearestMatrix[y][x-1] = closestColor; 

      var closestColor = getClosest(palette, { //calculate closet for j
        r:imageData.data[j],
        g:imageData.data[j+1],
        b:imageData.data[j+2]
      });

      var x = (j/4) % imageData.width; //determines row (%imageData.width keeps within matrix size)

      var y = Math.floor((j/4)/imageData.width); //determine column (should increase less frequently than row...)

      nearestMatrix[y][x] = closestColor; 
    }
  }
  return nearestMatrix;
}

/**************************************************************************************
FUNCTION PURPOSE: Finds which palette color a pixel is closet to
PARAMATERS: Palette array and the color of the pixel we are looking at
REFRENCES: https://medium.com/geekculture/implementing-k-means-clustering-from-scratch-in-javascript-13d71fbcb31e
***************************************************************************************/
function getClosest(palette, color) 
{
  var closestColor, closestColorIndex, prevDistance;

  for(var i = 0; i < palette.length; i++) //cycle through palette
  {
    var currentColor = palette[i]; //get the current color to compare to
    if(i == 0)
    {
      closestColor = currentColor;
      closestColorIndex = i;
      //eucledian distance (no square root because we are just using this to compare)
      prevDistance = ((closestColor.r - color.r) ** 2) + 
        ((closestColor.g - color.g) ** 2) +
        ((closestColor.b - color.b) ** 2); 

    }  
    else
    {
      var distance = ((currentColor.r - color.r) ** 2) + 
      ((currentColor.g - color.g) ** 2) +
      ((currentColor.b - color.b) ** 2); 
    
      
      if(distance < prevDistance) //if this color is closer in clolor to this colot than the ones we previously checked 
      {
          prevDistance = distance;
          closestColor = color;
          closestColorIndex = i;
      }
    }

  }
  return closestColorIndex;
}

/**************************************************************************************
FUNCTION PURPOSE: find the regions that will need labels (gets rid of small regions)
PARMATERS: the matrix that holds which palette color each pixel is closest to
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/

function findLabelRegions(matrix)
{
  // console.log("In find Label Regions");

  var width = matrix[0].length; //number of columns in row 0 of matrix
  var height = matrix.length; //number of rows

  var covered = [];

  for (var i = 0; i < height; i++) //through number of rows
  {
    covered[i] = new Array(width); // for each element of the array, make a new array of length width (#cols in row 0 of matrix)
    _.fill(covered[i],false); //fills covered array with all false values
  }

  var labelLocs = []; 

  for (var y = 0; y < height; y++)  //rows
  {
    for (var x = 0; x < width; x++) //columns
    {
      if (covered[y][x] == false) //if we have not yet checked this pixel
      {
        //find all near pixels that share the same palette color
        var region = getRegion(matrix, covered, x, y); 

        //region.x holds all the x values for the pixels with same palette color (length same as region.y.length)
        for(var i = 0; i < region.x.length; i++) 
        { 
          covered[region.y[i]][region.x[i]] = true; //mark true all that share same palette color
        }
      
        //checks to make sure we're not labeling very small regions
        if(region.x.length > 100) 
        {
          labelLocs.push(getLabelPlacement(matrix,region));//find where the label will go 
        }
        else //if the region is not big enough...
        {
          //remove the region
          
          if(region.y[0] > 0) 
          {
            //choose the palette color of the pixel to the left
            var newColor = matrix[region.y[0] - 1][region.x[0]]; 
          }
          else
          {
            var x = region.x[0];
            var y = region.y[0];
            
            while(matrix[y][x] == region.value)
            {
              y++;
            }
            var newColor = matrix[y][x];
          }
          
          //for our entire small region...
          for(var i = 0; i < region.x.length; i++)
          {
            //assign a new color from the palette (one of the near by colors)
            matrix[region.y[i]][region.x[i]] = newColor;
          } 
        }
      }
    }
  }
 return labelLocs; //return the locations of where the labels will be placed
}

/**************************************************************************************
FUNCTION PURPOSE: find how far the specific region with [y][x] spans
PARMATERS: the matrix that holds which palette color each pixel is closest to, the covered
  matrix that holds false values (if a pixel gets marked true, it is in the region) and our
  x and y value
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
var getRegion = function(matrix, cov, x, y) //function to find the regions 
{

  var covered = _.cloneDeep(cov); //recursively clones cov matrix

  //value holds our current pixel, and x and y are empty arrays that will hold the 
  //x and y values in the region
  var region = { value: matrix[y][x], x: [] , y: [] }; 
  var value = matrix[y][x]; //value is the pixel at the point it was called
 
  var queue = [[x,y]]; //array of coordinants that will hold the pixels connected with same palette color

  while(queue.length>0)
  {
    var coord = queue.shift(); //shift removes first element of array (coord holds first element)

    //if the current pixel we're looking at has not yet been visited, and if it has has the same pixel value
    if (covered[coord[1]][coord[0]] == false && matrix[coord[1]][coord[0]] == value) 
    {
      region.x.push(coord[0]); //put coord[0](x) in the x array of region
      region.y.push(coord[1]); //put coord[1](y) in the y array of region
      covered[coord[1]][coord[0]] = true; //mark those values as true in covered matrix

      if (coord[0] > 0) //if the x coordinant is 0
      {
        queue.push([coord[0] - 1, coord[1]]); //put the pixel to the left in the queue to check
      }

      if (coord[0] < matrix[0].length - 1) //put pixel to the right in the queue to check
      {
        queue.push([coord[0]+1, coord[1]]); 
      }

      //same thing for y 
      if (coord[1] > 0) 
      {
        queue.push([coord[0], coord[1]-1]);
      }

      if (coord[1] < matrix.length-1)
      {
        queue.push([coord[0], coord[1] + 1]);
      }
    }
  }
  //once finished, return our found region
  return region; 
}

/**************************************************************************************
FUNCTION PURPOSE: find the best space in our regions to place our labels
PARMATERS: the matrix that holds which palette color each pixel is closest to, and the region
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function getLabelPlacement(matrix, region)
{
  var bestI = 0;
  var best = 0;

  //region.x holds all the x values in the region. Region.x.length and region.y.length are the same
  for (var i = 0; i < region.x.length; i++) 
  {
    //calculate possible placements (moving in all directions)
    var goodness = labelTester(matrix, region.x[i], region.y[i], -1, 0) * 
      labelTester(matrix, region.x[i], region.y[i], 1, 0) *
      labelTester(matrix, region.x[i], region.y[i], 0, -1) *
      labelTester(matrix, region.x[i], region.y[i], 0, 1);

      //determine the best
      if(goodness > best)
      {
        best = goodness;
        bestI = i;
      }
  }
  //return bestI as a region object
  return {
    value: region.value,
    x: region.x[bestI], //returns the x value of the best found placement
    y: region.y[bestI]  //returns the y value of the best found placement
  };
}

/**************************************************************************************
FUNCTION PURPOSE: finds a space for our number label. This is called in getLabelPlacement
PARMATERS: the matrix that holds which palette color each pixel is closest to, the x and
  y value of our pixel, and then the numbers we want to increase our x and y values by
  (incX, incY)
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function labelTester(matrix, x, y, incX, incY)
{
  var value = matrix[y][x];
  var count = -1;

  //while x is greater than 0 and x < number of columns in row 0 of matrix and 
  //y is greater than 0 and y is less than the number or rows 
  //and the value in our matrix array hasn't changed 
  while( x>= 0 && x < matrix[0].length && y >= 0 && y < matrix.length && matrix[y][x] == value) 
  {
   count++;
   x += incX; //move in our sent in directions
   y += incY; 
  }

  return count; //return the amount of space the current run through has found
}

/**************************************************************************************
FUNCTION PURPOSE: Identifies where the outline will be
PARMATERS: the matrix that holds which palette color each pixel is closest to
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function outline(mat) 
{
  var width = mat[0].length;
  var height = mat.length;
  var line = [];

  //make line a matrix (same saize as our mat matrix (the matrix that holds palette colors))
  for (var i = 0; i < height; i++) 
  {
    line[i] = new Array(width);
  }

  for (var y = 0; y < height; y++) 
  {
    for (var x = 0; x < width; x++) 
    {
      //true means next pixel shares palette color
      if(neighborsSame(mat, x, y) == true) 
      {
        //this will be a region so it does not get a line
        line[y][x] = 0;
      } 
      else //next pixel does not share palette color
      {
        //this will not be a region, so it gets a line
        line[y][x] = 1;
      } 
    }
  }

  //return our line matrix, which will hold a 1 of there should be a line, and a 0 if there shouldn't be
  return line;
}

/**************************************************************************************
FUNCTION PURPOSE: Looks at a sent in pixel and determines if nearby pixels share the same
  palette color. This will help us create our outline, because if two near pixels have
  different colors, they should be seperated by a line
PARMATERS: Matrix that holds palette colors, and the x and y value of the current pixel
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function neighborsSame(mat, x, y) 
{
  var width = mat[0].length;
  var height = mat.length;

  //holds current pixel color (closest to palette)
  var val = mat[y][x];
  var xRel = [1, 0];
  var yRel = [0, 1];

  //xRel.length = 2
  for (var i = 0; i < xRel.length; i++) 
  {
    //increase either x or y by 1 (move to the next pixel)
    var xx = x + xRel[i];
    var yy = y + yRel[i];

    if (xx >= 0 && xx < width && yy >= 0 && yy < height) 
    {
      //if this next pixel does not share a palette color
      if (mat[yy][xx] != val) 
      {
        return false;
      }
    }
  }
  //next pixel does share a palette colore
  return true;
}

/**************************************************************************************
FUNCTION PURPOSE: Opens Eye Dropper on palette canvas onclick
PARMATERS: none
REFRENCES:  https://dev.to/madsstoumann/introducing-the-eyedropper-api-14d7
***************************************************************************************/
async function pickColor() 
{
  //creates new eyedropper Object
  const ED = new EyeDropper();
  const result = await ED.open();

  //increase the number of colors
  numColors ++; 

  //if exceeding the color limit
  if(numColors > colorLimit)
  {
    numColors--;
    alert("You have exceeded the number of colors");  //alert
  }
  else
  {
    //get palette currently on
    var c = document.getElementById("palette" + numColors);
    //get the context of the palette
    var cContext = c.getContext("2d");
    //outine around palette box
    cContext.strokeStyle = "#000000";
    //set new color to fill(choosen by eyedropper)
    cContext.fillStyle = result.sRGBHex; 
    //store current color in palette array (hexToRgb converts them to rgb values)
    palette[numColors-1] = hexToRgb(result.sRGBHex); 
    //fill palette with new color
    cContext.fillRect(0,0, c.width, c.height);
    //black outline
    cContext.strokeRect(0,0, c.width, c.height);

    if(palette[numColors-1].r < 100 && palette[numColors-1].g < 100 && palette[numColors-1].b < 100 )
    {
      cContext.fillStyle = "#FFFFFF";
    }
    else
    {
      cContext.fillStyle = "#000000";
    }
    cContext.textAlign = "center";
    cContext.fillText(numColors, c.width/2, c.height/2); 
  }
}

/**************************************************************************************
FUNCTION PURPOSE: Convert the hex value of our eyedropper color to rgb
PARMATERS: The hex value of the number
REFRENCES: https://stackoverflow.com/questions/5623838/rgb-to-hex-and-hex-to-rgb
***************************************************************************************/
function hexToRgb(hex) {
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  return result ? {
    r: parseInt(result[1], 16),
    g: parseInt(result[2], 16),
    b: parseInt(result[3], 16)
  } : null;
}